'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5247] on 6 June 2003 at 12:08:47 am'!
"Change Set:		yaxo-2.0
Date:			6 June 2003
Author:			Michael Rueger, Stephen Pair, Simon Dobson, Andreas Raab

This change set upgrades Yaxo to version 2.0.
What's new:
- name space handling (turned off by default for compatibility)
  adopted the code provided by Simon to have proper name space handling. Largely untested, might break some of the existing applications. That's why it is turned off by default.
- some speed-up fixes by Andreas and myself
- misc fixes

The existing SUnit test suite still fails way to many tests although a lot of the errors and failures occur in 16 Bit character encoding and DTD parsing (which is incomplete).
"!

XMLNode subclass: #XMLNodeWithElements
	instanceVariableNames: 'elements uri namespace '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!
Object subclass: #XMLTokenizer
	instanceVariableNames: 'stream nestedStreams entities externalEntities parameterEntities parsingMarkup markedPosition peekChar validating attributeBuffer nameBuffer '
	classVariableNames: 'CharEscapes DigitTable LiteralChars NameDelimiters SeparatorTable '
	poolDictionaries: ''
	category: 'XML-Parser'!
XMLTokenizer subclass: #SAXDriver
	instanceVariableNames: 'saxHandler useNamespaces scope currentBindings validateAttributes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!
Object subclass: #XMLWriter
	instanceVariableNames: 'stream stack scanner canonical namespaceStack '
	classVariableNames: 'XMLTranslation XMLTranslationMap '
	poolDictionaries: ''
	category: 'XML-Parser'!

!SAXHandler methodsFor: 'content' stamp: 'mir 6/5/2003 19:05'!
endElement: elementName namespace: namespace namespaceURI: namespaceURI qualifiedName: qualifiedName
	"This call corresponds to the Java SAX call
	endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName).
	By default this call is mapped to the following more convenient call:"

	self endElement: elementName! !

!SAXHandler methodsFor: 'content' stamp: 'mir 6/5/2003 16:50'!
startElement: localName namespaceURI: namespaceUri namespace: namespace attributeList: attributeList
	"This call corresonds to the Java SAX call
	startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName, Attributes atts).
	By default this call is mapped to the following more convenient call:"

	self startElement: localName attributeList: attributeList! !

!SAXHandler methodsFor: 'accessing' stamp: 'sd 5/23/2003 15:58'!
namespaces
	^ self driver namespaces! !

!SAXHandler methodsFor: 'accessing' stamp: 'mir 6/5/2003 19:28'!
useNamespaces: aBoolean
	self driver useNamespaces: aBoolean! !


!SAXHandler class methodsFor: 'instance creation' stamp: 'sd 5/23/2003 15:19'!
on: aStream
	| driver parser |
	driver _ SAXDriver on: aStream.
	driver validating: true.
	parser _ self new driver: driver.
	^parser! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'mir 6/5/2003 19:13'!
parseDocumentFrom: aStream
	|  parser |
	parser _ self on: aStream.
	parser startDocument.
	parser parseDocument.
	^parser! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'mir 6/5/2003 19:15'!
parserOnFileNamed: fileName
	^self parserOnFileNamed: fileName readIntoMemory: false! !

!SAXHandler class methodsFor: 'instance creation' stamp: 'mir 6/5/2003 19:14'!
parserOnFileNamed: fileName readIntoMemory: readIntoMemory
	| stream  |
	stream _ FileDirectory default readOnlyFileNamed: fileName.
	readIntoMemory
		ifTrue: [stream _ stream contentsOfEntireFile readStream].
	^self on: stream! !


!XMLDOMParser methodsFor: 'content' stamp: 'mir 6/5/2003 19:05'!
endElement: localName namespace: namespace namespaceURI: uri qualifiedName: qualifiedName
	| currentElement |
	currentElement _ self pop.
	currentElement qualifiedName = qualifiedName
		ifFalse: [self driver errorExpected: 'End tag "', qualifiedName , '" doesn''t match "' , currentElement qualifiedName  , '".']! !

!XMLDOMParser methodsFor: 'content' stamp: 'mir 6/5/2003 16:50'!
startElement: localName namespaceURI: namespaceUri namespace: namespace attributeList: attributeList
	| newElement |
	newElement _ XMLElement named: localName namespace: namespace uri: namespaceUri attributes: attributeList.
	self incremental
		ifFalse: [self stack isEmpty
			ifFalse: [self top addElement: newElement]].
	self push: newElement! !

!XMLDOMParser methodsFor: 'parsing' stamp: 'mir 6/5/2003 19:29'!
domDocument
	[self startDocument; parseDocument]
		ensure: [self driver stream close].
	^document! !


!XMLNodeWithElements methodsFor: 'accessing' stamp: 'mir 6/4/2003 19:23'!
elementAt: entityName ifAbsent: aBlock
	elements
		ifNil: [^aBlock value].
	^self elements detect: [:each | each name = entityName] ifNone: [^aBlock value]! !

!XMLNodeWithElements methodsFor: 'name space' stamp: 'mir 6/5/2003 15:20'!
namespace
	^ namespace! !

!XMLNodeWithElements methodsFor: 'name space' stamp: 'mir 6/5/2003 15:21'!
namespace: ns uri: u
	namespace _ ns.
	uri _ u! !

!XMLNodeWithElements methodsFor: 'name space' stamp: 'mir 6/5/2003 15:20'!
namespaceURI
	^ uri! !


!XMLDocument methodsFor: 'accessing' stamp: 'mir 5/16/2003 14:09'!
encoding	
	^encoding ifNil: ['UTF-8']! !

!XMLDocument methodsFor: 'printing' stamp: 'mir 5/16/2003 14:08'!
printXMLOn: writer
	version ifNotNil: [writer xmlDeclaration: self version encoding: self encoding].
	super printXMLOn: writer! !


!XMLElement methodsFor: 'accessing' stamp: 'sd 5/25/2003 18:25'!
name
	^ self qualifiedName! !

!XMLElement methodsFor: 'accessing' stamp: 'sd 5/25/2003 18:25'!
tag
	^ self name asSymbol! !

!XMLElement methodsFor: 'accessing' stamp: 'mir 6/5/2003 12:02'!
valueFor: aSymbol 
	^self valueFor: aSymbol ifAbsent: ['']! !

!XMLElement methodsFor: 'name space' stamp: 'sd 5/25/2003 18:24'!
localName
	^ name! !

!XMLElement methodsFor: 'name space' stamp: 'mir 6/5/2003 15:20'!
qualifiedName
	^self namespace
		ifNil: [self localName]
		ifNotNil: [self namespace , ':' , self localName]! !


!XMLElement class methodsFor: 'instance creation' stamp: 'mir 6/5/2003 15:21'!
named: aString namespace: ns uri: uri attributes: attributeList
	^self new
		name: aString;
		namespace: ns uri: uri;
		setAttributes: attributeList! !


!XMLTokenizer methodsFor: 'handling tokens' stamp: 'mir 6/5/2003 14:53'!
handleXMLDecl: attributes namespaces: namespaces
	attributes keysAndValuesDo: [:key :value |
		self log: key , '->' , value]! !

!XMLTokenizer methodsFor: 'private' stamp: 'mir 3/14/2003 23:09'!
fastStreamStringContents: writeStream
	| newSize |
	newSize _ writeStream position.
	^(String new: newSize)
		replaceFrom: 1
		to: newSize
		with: writeStream originalContents
		startingAt: 1! !

!XMLTokenizer methodsFor: 'private' stamp: 'mir 3/14/2003 19:27'!
readNumberBase: base
	"Read a hex number from stream until encountering $; "

	| value digit |
	value _ 0.
	digit _ DigitTable at: self peek asciiValue.
	digit < 0
		ifTrue: [self error: 'At least one digit expected here'].
	self next.
	value _ digit.
	[digit _ DigitTable at: self peek asciiValue.
	digit < 0
		ifTrue: [^value]
		ifFalse: [
			self next.
			value _ value * base + digit]
		] repeat.
	^ value! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 6/5/2003 16:32'!
nextAttributeInto: attributes namespaces: namespaces

	| attrName attrValue |
	attrName _ self nextName.
	self skipSeparators.
	self next == $=
		ifFalse: [self errorExpected: '='].
	self skipSeparators.
	attrValue _ self nextAttributeValue.

	(self usesNamespaces
		and: [(attrName findString: 'xmlns') = 1])
		ifTrue: [attrName size > 6
			ifTrue: [namespaces at: (attrName copyFrom: 7 to: attrName size) put: attrValue]
			ifFalse: [namespaces at: attrName put: attrValue]]
		ifFalse: [attributes at: attrName put: attrValue]! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 3/14/2003 23:34'!
nextAttributeValue
	| delimiterChar attributeValueStream nextChar nextPeek referenceString entity entityValue |
	delimiterChar _ self next.
	(delimiterChar == $"
		or: [delimiterChar == $'])
		ifFalse: [self errorExpected: 'Attribute value delimiter expected.'].
	attributeValueStream _ attributeBuffer reset.
	[
	nextPeek _ nextChar _ self next.
	nextChar ifNil: [self errorExpected: 'Character expected.'].
	nextChar == $&
		ifTrue: [
			self peek == $#
				ifTrue: [
					nextPeek _ nil.
					nextChar _ self nextCharReference]
				ifFalse: [
					referenceString _ self nextLiteral.
					self next == $;
						ifFalse: [self errorExpected: ';'].
					entity _ self entity: referenceString.
					entityValue _ entity valueForContext: #content.
					(self class isCharEscape: entityValue)
						ifTrue: [
							nextPeek _ nil.
							nextChar _ entityValue]
						ifFalse: [
							entityValue _ entityValue asString.
							entityValue isEmpty
								ifTrue: [nextPeek _ nextChar _ nil]
								ifFalse: [
									self pushStream: (ReadStream on: entityValue asString).
									nextPeek _ nextChar _ self next]]]].
	nextPeek == delimiterChar]
		whileFalse: [
			nextChar ifNotNil: [attributeValueStream nextPut: nextChar]].
	^self fastStreamStringContents: attributeValueStream
"	^attributeValueStream contents"! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 3/14/2003 19:14'!
nextCharReference
	| base charValue nextChar numberString |
	self next == $#
		ifFalse: [self errorExpected: 'character reference'].
	base _ self peek == $x
		ifTrue: [
			self next.
			16]
		ifFalse: [10].
"	numberString _ (self nextUpTo: $;) asUppercase.
	charValue _ [Number readFrom: numberString base: base] on: Error do: [:ex | self errorExpected: 'Number.'].
"	charValue _ [self readNumberBase: base] on: Error do: [:ex | self errorExpected: 'Number.'].
	(nextChar _ self next) == $;
		ifFalse: [self errorExpected: '";"'].
	^charValue > 255
		ifTrue: [^Character space]
		ifFalse: [charValue asCharacter]! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 3/14/2003 23:27'!
nextEndTag
	| string |
	"Skip /"
	self next.
	self skipSeparators.
	string _ self nextTrimmedBlanksUpTo: $>.
	"string _ (self nextUpTo: $>) withBlanksTrimmed."
	self handleEndTag: string! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 3/14/2003 19:56'!
nextLiteral
	| resultStream nextChar resultString |
	resultStream _ (String new: 10) writeStream.
	((nextChar _ self peek) isLetter
		or: [nextChar == $_])
		ifFalse: [self errorExpected: 'Name literal.'].
	[nextChar _ self peek.
	(LiteralChars at: nextChar asciiValue+1)
		ifTrue: [
			nextChar == $&
				ifTrue: [
					nextChar _ self next.
					resultStream nextPut: (self peek == $#
						ifTrue: [self nextCharReference]
						ifFalse: [^resultStream contents])]
				ifFalse: [
					resultStream nextPut: self next]]
		ifFalse: [resultString _ resultStream contents.
			resultString isEmpty
				ifTrue: [self errorExpected: 'Name literal']
				ifFalse: [^resultString]]] repeat! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 3/14/2003 23:10'!
nextName
	| nextChar |
	nameBuffer reset.
	self peek == $.
		ifTrue: [self malformedError: 'Character expected.'].
	[(nextChar _ self peek)
		ifNil: [self errorExpected: 'Character expected.'].
	NameDelimiters at: nextChar asciiValue] whileFalse: [
			nameBuffer nextPut: self next].
	^self fastStreamStringContents: nameBuffer
"	^nameBuffer contents"! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 6/5/2003 22:37'!
nextTag
	| tagName attributes nextChar namespaces |
	(self peek = $/)
		ifTrue: [^self nextEndTag].
	tagName _ self nextName.
	self skipSeparators.
	attributes _ Dictionary new: 33.
	namespaces _ Dictionary new: 5.
	[(nextChar _ self peek) == $> or: [nextChar == $/]] whileFalse: [
		self checkAndExpandReference: #content.
		self nextAttributeInto: attributes namespaces: namespaces.
		self skipSeparators.].
	self handleStartTag: tagName attributes: attributes namespaces: namespaces.
	self next == $/
		ifTrue: [
			self handleEndTag: tagName.
			self next].
	! !

!XMLTokenizer methodsFor: 'tokenizing' stamp: 'mir 6/5/2003 14:52'!
nextXMLDecl
	| attributes nextChar namespaces |
	self skipSeparators.
	attributes _ Dictionary new.
	namespaces _ Dictionary new.
	[(nextChar _ self peek) == $?] whileFalse: [
		self nextAttributeInto: attributes namespaces: namespaces.
		self skipSeparators.].
	self next.
	self next == $>
		ifFalse: [self errorExpected: '> expected.'].
	self handleXMLDecl: attributes namespaces: namespaces! !

!XMLTokenizer methodsFor: 'testing' stamp: 'mir 6/5/2003 16:33'!
usesNamespaces
	^false! !

!XMLTokenizer methodsFor: 'initialize' stamp: 'mir 3/14/2003 19:27'!
initialize
	parsingMarkup _ false.
	validating _ false.
	attributeBuffer _ WriteStream on: (String new: 128).
	nameBuffer _ WriteStream on: (String new: 128)! !

!XMLTokenizer methodsFor: 'errors' stamp: 'mir 5/14/2003 18:27'!
errorExpected: expectedString
	| actualString |
	actualString := ''.
	self atEnd
		ifFalse: [
			[actualString := self next: 20]
				on: Error
				do: [:ex | ]].
	self parseError: 'XML expected ' , expectedString printString , ': ' , actualString! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 3/14/2003 22:58'!
atEnd
	nestedStreams == nil
		ifTrue: [^peekChar == nil and: [stream atEnd]].
	^stream atEnd
		ifTrue: [
			self popNestingLevel.
			self atEnd]
		ifFalse: [false]! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 3/14/2003 22:59'!
checkNestedStream
	nestedStreams == nil
		ifFalse: [(peekChar == nil and: [self stream atEnd])
			ifTrue: [
				self popNestingLevel.
				self checkNestedStream]]
! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 3/14/2003 23:04'!
next
	"Return the next character from the current input stream. If the current stream is at end pop to next nesting level if there is one.
	Due to the potential nesting of original document, included documents and replacment texts the streams are held in a stack representing the nested streams. The current stream is the top one."
	| nextChar |
	peekChar
		ifNil: [
			nestedStreams ifNotNil: [self checkNestedStream].
			^nextChar _ stream next]
		ifNotNil: [
			nextChar _ peekChar.
			peekChar _ nil.
			^nextChar].
	! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 3/14/2003 23:27'!
nextTrimmedBlanksUpTo: delimiter
	| resultStream nextChar |
	resultStream _ WriteStream on: (String new: 10).
	nextChar _ nil.
	[peekChar _ self peek.
	peekChar
		ifNotNil: [
			[peekChar == $ 
				and: [nextChar == $ ]]
				whileTrue: [peekChar _ self next]].
	(nextChar _ self next) == delimiter]
		whileFalse: [resultStream nextPut: nextChar].
	nextChar == delimiter
		ifFalse: [self parseError: 'XML no delimiting ' , delimiter printString , ' found'].
	^resultStream contents
! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 5/14/2003 18:44'!
nextUpTo: delimiter
	| resultStream nextChar |
	resultStream _ WriteStream on: (String new: 10).
	[self atEnd or: [(nextChar _ self next) == delimiter]]
		whileFalse: [resultStream nextPut: nextChar].
	nextChar == delimiter
		ifFalse: [self parseError: 'XML no delimiting ' , delimiter printString , ' found'].
	^resultStream contents
! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 3/14/2003 23:05'!
peek
	"Return the next character from the current input stream. If the current stream poop to next nesting level if there is one.
	Due to the potential nesting of original document, included documents and replacment texts the streams are held in a stack representing the nested streams. The current stream is the top one."
	peekChar
		ifNil: [
			nestedStreams ifNotNil: [self checkNestedStream].
			^peekChar _ stream next]
		ifNotNil: [^peekChar]! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 3/14/2003 22:54'!
skipSeparators
	| nextChar |
	[((nextChar _ self peek) == nil)
		or: [SeparatorTable at: nextChar asciiValue+1]]
		whileFalse: [self next].
	(nestedStreams == nil or: [self atEnd not])
		ifFalse: [
			self checkNestedStream.
			self skipSeparators]! !

!XMLTokenizer methodsFor: 'streaming' stamp: 'mir 5/14/2003 18:45'!
unpeek
	peekChar
		ifNotNil: [
			self stream pushBack: (String with: peekChar).
			peekChar _ nil]! !


!SAXDriver methodsFor: 'accessing' stamp: 'mir 6/5/2003 16:29'!
useNamespaces: aBoolean
	useNamespaces := aBoolean.
	useNamespaces
		ifTrue: [self initScope]! !

!SAXDriver methodsFor: 'handling tokens' stamp: 'mir 6/5/2003 19:35'!
handleEndTag: elementName
	| namespace localName namespaceURI |

	self usesNamespaces
		ifTrue: [
			self splitName: elementName into: [:ns :ln |
				namespace _ ns.
				localName _ ln].

			"ensure our namespace is defined"
			namespaceURI := self namespaceURIOf: namespace.
			namespaceURI
				ifNil: [self parseError: 'Start tag ' , elementName , ' refers to undefined namespace ' , namespace asString].

			"call the handler"
			self saxHandler
				checkEOD; 
				endElement: localName namespace: namespace namespaceURI: namespaceURI qualifiedName: elementName.
			self leaveScope]
		ifFalse: [
			"call the handler"
			self saxHandler
				checkEOD; 
				endElement: elementName namespace: nil namespaceURI: nil qualifiedName: elementName]! !

!SAXDriver methodsFor: 'handling tokens' stamp: 'mir 6/5/2003 19:35'!
handleStartTag: elementName attributes: attributeList namespaces: namespaces

	| localName namespace namespaceURI |

	self usesNamespaces
		ifTrue: [
			self enterScope.
				"declare any namespaces"	
				namespaces keysAndValuesDo: [:ns :uri |
					self declareNamespace: ns uri: uri].

			self splitName: elementName into: [:ns :ln |
				namespace _ ns.
				localName _ ln].

			"ensure our namespace is defined"
			namespaceURI := self namespaceURIOf: namespace.
			namespaceURI
				ifNil: [self parseError: 'Start tag ' , elementName , ' refers to undefined namespace ' , namespace asString].

			self validatesAttributes
				ifTrue: [self validateAttributes: attributeList].
			"call the handler"
			self saxHandler
				checkEOD; 
				startElement: localName namespaceURI: namespaceURI namespace: namespace attributeList: attributeList]
		ifFalse: [
			"call the handler"
			self saxHandler
				checkEOD; 
				startElement: elementName namespaceURI: nil namespace: nil attributeList: attributeList]! !

!SAXDriver methodsFor: 'handling tokens' stamp: 'mir 6/5/2003 15:24'!
handleXMLDecl: attributes  namespaces: namespaces
	self saxHandler
		checkEOD; 
		documentAttributes: attributes.
	namespaces keysAndValuesDo: [:ns :uri |
		self declareNamespace: ns uri: uri]! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/4/2003 15:51'!
currentScope
	^self scope last! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 19:31'!
declareNamespace: ns uri: uri
	"Declare the given name space prefix with the given URL"

	ns = 'xmlns'
		ifTrue: [^self defaultNamespace: uri].
	self establishLocalBindings.
	currentBindings removeKey: ns ifAbsent: [].
	currentBindings at: ns put: uri! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/4/2003 15:52'!
defaultNamespace
	^self currentScope first! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/4/2003 15:54'!
defaultNamespace: ns
	"Declare the default namespace."

	self currentScope at: 1 put: ns! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 19:36'!
defaultNamespaceURI
	^self defaultNamespace! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 19:28'!
enterScope
	self scope addLast: { self defaultNamespace. nil. currentBindings. }! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/4/2003 16:08'!
establishLocalBindings
	(self currentScope at: 2)
		ifNil: [
			currentBindings := currentBindings copy.
			self currentScope at: 2 put: currentBindings]! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/4/2003 16:05'!
leaveScope
	| leftScope |
	leftScope := self scope removeLast.
	currentBindings := (self currentScope at: 2) ifNil: [leftScope at: 3]! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 19:32'!
namespaceAliases: namespace
	"Locate all namespaces that are aliases of the given URI."

	| aliases uri |
	aliases _ Set new.
	uri _ self namespaceURIOf: namespace ifAbsent: [self parseError: 'Attribute refers to undefined namespace ' , namespace asString ].
	currentBindings keysAndValuesDo: [:ns :u |
		(u = uri
			and: [ns ~= namespace])
			ifTrue: [aliases add: ns]].
	^ aliases! !

!SAXDriver methodsFor: 'namespaces' stamp: 'sd 5/28/2003 09:33'!
namespaceURIOf: ns
	"Retrieve the URI of the given namespace prefix, if it is defined. A nil namespace
	returns the global namespace"

	^ self namespaceURIOf: ns ifAbsent: [ nil ]! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 19:32'!
namespaceURIOf: ns ifAbsent: aBlock
	"Retrieve the URI of the given namespace prefix, if it is defined. 
	A nil namespace returns the default namespace. 
	If no namespace can be found the value of the block is returned"

	^ns
		ifNil: [self defaultNamespaceURI]
		ifNotNil: [currentBindings at: ns ifAbsent: aBlock]! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 19:32'!
namespaces
	^currentBindings! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/3/2003 17:10'!
scope
	^scope! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 17:04'!
splitName: aName into: twoArgsBlock
	"Split the name into namespace and local name (the block arguments).
	Handle both qualified and unqualified names using the default name space"

	| i ns ln |
	i _ aName findString: ':'.
	i = 0
		ifTrue: [
			ns := nil.
			ln := aName]
		ifFalse: [
			ns := aName copyFrom: 1 to: (i - 1).
			ln := aName copyFrom: i+1 to: aName size].
	twoArgsBlock value: ns value: ln! !

!SAXDriver methodsFor: 'namespaces' stamp: 'mir 6/5/2003 17:16'!
validateAttributes: attributeList
	"check all attribute namespaces are defined and not duplicated by aliasing"
	| namespace localName |
	attributeList keysDo: [:attrName |
		self splitName: attrName into: [:ns :ln |
			namespace _ ns.
			localName _ ln].
		namespace ifNotNil: [
			(self namespaceAliases: namespace) do: [:alias |
				(attributeList includesKey: alias , ':' , localName)
					ifTrue: [self parseError: 'Attributes ' , attrName , ' and ' , alias , ':' , localName , ' are aliased to namespace ' , (self namespaceURIOf: namespace) ]]]]! !

!SAXDriver methodsFor: 'testing' stamp: 'mir 6/5/2003 16:30'!
usesNamespaces
	^useNamespaces! !

!SAXDriver methodsFor: 'testing' stamp: 'mir 6/5/2003 17:06'!
validatesAttributes
	^validateAttributes! !

!SAXDriver methodsFor: 'initialization' stamp: 'mir 6/5/2003 19:31'!
initScope
	scope := OrderedCollection new: 20.
	currentBindings := Dictionary new.
	scope addLast: {'http://www.w3.org/TR/REC-xml-names'. currentBindings. nil. }.
! !

!SAXDriver methodsFor: 'initialization' stamp: 'mir 6/5/2003 16:29'!
initialize
	super initialize.
	useNamespaces := false.
	validateAttributes := false! !


!XMLTokenizer class methodsFor: 'class initialization' stamp: 'mir 3/14/2003 22:54'!
initialize
	"XMLTokenizer initialize"

	| nameDelimiters |

	CharEscapes _ #( $& $" $' $> $< ) asSet.

	SeparatorTable  _ Array new: 256.
	SeparatorTable atAllPut: true.
	#(9 10 12 13 32) do: [:each | SeparatorTable at: each+1 put: false].

	LiteralChars _ Array new: 256.
	LiteralChars atAllPut: false.
	':-_.' do: [:each | LiteralChars at: each asciiValue put: true].
	1 to: 256 do: [:i | ((i-1) asCharacter isDigit or: [(i-1) asCharacter isLetter])
		ifTrue: [LiteralChars at: i put: true]].

	nameDelimiters _ #(9 10 12 13 32 61 "$= asInteger 61" 62 "$> asInteger" 47 "$/ asInteger").
	NameDelimiters _ Array new: 256.
	NameDelimiters atAllPut: false.
	nameDelimiters do: [:each | NameDelimiters at: each put: true].

	DigitTable _ Array new: 256.
	DigitTable atAllPut: -1.
	($0 to: $9) do: [:each | DigitTable at: each asciiValue put: each digitValue].
	($A to: $F) do: [:each | DigitTable at: each asciiValue put: each digitValue].
! !


!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 11:04'!
attribute: attributeName value: attributeValue
	self stream
		space;
		nextPutAll: attributeName.
	self
		eq;
		putAsXMLString: attributeValue! !

!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 11:52'!
endTag: tagName
	self endTag: tagName xmlns: nil! !

!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 11:52'!
endTag: tagName xmlns: xmlns
	self popTag: tagName.
	self stream
		nextPutAll: '</'.
	(xmlns notNil
		and: [xmlns ~= self nameSpace])
		ifTrue: [self stream
			nextPutAll: xmlns;
			nextPut: $:].
	stream nextPutAll: tagName.
	self endTag.
! !

!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 11:13'!
flush
	self stream flush! !

!XMLWriter methodsFor: 'writing xml' stamp: 'ar 12/15/2002 15:56'!
pcData: aString
	| lastIndex nextIndex |
	lastIndex := 1.
	"Unroll the first search to avoid copying"
	nextIndex := String findFirstInString: aString inSet: XMLTranslationMap startingAt: lastIndex.
	nextIndex = 0 ifTrue:[^self stream nextPutAll: aString].
	[self stream nextPutAll: (aString copyFrom: lastIndex to: nextIndex-1).
	self stream nextPutAll: (XMLTranslation at: (aString at: nextIndex)).
	lastIndex := nextIndex + 1.
	nextIndex := String findFirstInString: aString inSet: XMLTranslationMap startingAt: lastIndex.
	nextIndex = 0] whileFalse.
	self stream nextPutAll: (aString copyFrom: lastIndex to: aString size).! !

!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 11:51'!
startTag: tagName
	self startTag: tagName xmlns: nil! !

!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 11:51'!
startTag: tagName xmlns: xmlns
	self stream
		nextPut: $<.
	(xmlns notNil
		and: [xmlns ~= self nameSpace])
		ifTrue: [self stream
			nextPutAll: xmlns;
			nextPut: $:].
	self stream
		nextPutAll: tagName.
	"self canonical
		ifFalse: [self stream space]."
	self pushTag: tagName! !

!XMLWriter methodsFor: 'writing xml' stamp: 'mir 5/20/2003 12:17'!
xmlDeclaration: versionString encoding: encodingString
	self canonical
		ifFalse: [
			self
				startPI: 'xml';
				attribute: 'version' value: versionString;
				attribute: 'encoding' value: encodingString;
				endPI.
			self stream flush]! !

!XMLWriter methodsFor: 'private' stamp: 'mir 5/8/2003 18:17'!
namespaceStack
	namespaceStack ifNil: [namespaceStack := OrderedCollection new].
	^namespaceStack! !

!XMLWriter methodsFor: 'private tags' stamp: 'mir 5/20/2003 12:13'!
endPI
	self stream nextPutAll: ' ?>'! !

!XMLWriter methodsFor: 'namespaces' stamp: 'mir 5/20/2003 14:27'!
enterNameSpace: xmlns
	xmlns ifNil: [^self].
	self nameSpace ~= xmlns
		ifTrue: [
			self attribute: 'xmlns' value: xmlns.
			self namespaceStack addLast: xmlns]! !

!XMLWriter methodsFor: 'namespaces' stamp: 'mir 5/20/2003 12:03'!
exitNameSpace: xmlns
	xmlns ifNil: [^self].
	namespaceStack
		ifNotNil: [
			namespaceStack isEmpty
				ifFalse: [namespaceStack removeLast]]! !

!XMLWriter methodsFor: 'namespaces' stamp: 'mir 5/8/2003 18:20'!
nameSpace
	^namespaceStack
		ifNotNil: [
			namespaceStack isEmpty
				ifTrue: [nil]
				ifFalse: [namespaceStack last]]! !


!XMLWriter class methodsFor: 'class initialization' stamp: 'ar 12/13/2002 01:04'!
initialize
	"XMLWriter initialize"

	XMLTranslation := Dictionary new.
	XMLTranslation
		at: Character cr put: '&#13;';
		at: Character lf put: '&#10;';
		at: Character tab put: '&#9;';
		at: $& put: '&amp;';
		at: $< put: '&lt;';
		at: $> put: '&gt;';
"		at: $' put: '&apos;'; "
		at: $" put: '&quot;'.
	XMLTranslationMap := ByteArray new: 256.
	XMLTranslation keysDo:[:ch| XMLTranslationMap at: ch asciiValue+1 put: 1].
! !


Object subclass: #XMLWriter
	instanceVariableNames: 'stream stack namespaceStack scanner canonical '
	classVariableNames: 'XMLTranslation XMLTranslationMap '
	poolDictionaries: ''
	category: 'XML-Parser'!

SAXDriver removeSelector: #handleStartTag:attributes:!
SAXDriver removeSelector: #handleXMLDecl:!
XMLTokenizer subclass: #SAXDriver
	instanceVariableNames: 'saxHandler scope currentBindings useNamespaces validateAttributes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser'!
XMLTokenizer removeSelector: #handleXMLDecl:!
XMLTokenizer removeSelector: #nextAttributeInto:!
Object subclass: #XMLTokenizer
	instanceVariableNames: 'stream nestedStreams entities externalEntities parameterEntities parsingMarkup markedPosition peekChar validating nameBuffer attributeBuffer '
	classVariableNames: 'CharEscapes DigitTable LiteralChars NameDelimiters SeparatorTable '
	poolDictionaries: ''
	category: 'XML-Parser'!
SAXHandler removeSelector: #endElement:namespaceURI:qualifiedName:!
SAXHandler removeSelector: #startElement:namespaceURI:qualifiedName:attributeList:!
"Postscript:
"
XMLWriter initialize.
XMLTokenizer initialize.
!

